#include "CRUL_server_call_httpserver.h"
#include <string>
#include <sstream>
#include <iostream>
#include"tinyxml2.h" 
using namespace tinyxml2;
size_t write_data(void* ptr, size_t size, size_t nmemb, void* stream) {
	string data((const char*)ptr, (size_t)size * nmemb);
	*((stringstream*)stream) << data << endl;
	return size * nmemb;
}



string callHttpserver(string signinfoJsonString, string url){
	CURL *curl;
	CURLcode res;
	curl = curl_easy_init();
	std::stringstream out;
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		struct curl_slist *headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/json");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		const char *data = signinfoJsonString.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		res = curl_easy_perform(curl);
		if (res != 0) {
			string errMessage = curl_easy_strerror(res);
		}
		printf("ֵ%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("str_json===>%s\n", str_json.c_str());
	return str_json;
}

string sendOA() {
	CURL *curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, "https://bpmtest10.chint.com/Portal/Webservices/BPMExtendService.asmx/SetItemValues");
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist *headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		const char *data = "sfId=111177777&instanceId=3333&entityParamValues=ddd";
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
}
string callHttpGet(string url) {
	void* curl = curl_easy_init();
	// URL
	std::stringstream out;
	curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
	curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
	// ýݵĴʹű
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);

	// ִHTTP GET
	CURLcode res = curl_easy_perform(curl);
	if (res != CURLE_OK) {
		fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
	}

	// ݴoutУ֮
	//cout << out.str() << endl;
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("str_json===>%s\n", str_json.c_str());
	return str_json;
}
string sendOA(string sfid, string instanceId, string entityParamValues, string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, false);
		string temp;
		temp.append("sfId=").append(sfid).append("&instanceId=").append(instanceId).append("&entityParamValues=").append(entityParamValues);
		printf("temp=%s\n", temp.c_str());
		const char* data = temp.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		//curl_easy_strerror
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
	return str_json;
}
char* G2U(const char* gb2312)
{
	int len = MultiByteToWideChar(CP_ACP, 0, gb2312, -1, NULL, 0);
	wchar_t* wstr = new wchar_t[len + 1];
	memset(wstr, 0, len + 1);
	MultiByteToWideChar(CP_ACP, 0, gb2312, -1, wstr, len);
	len = WideCharToMultiByte(CP_UTF8, 0, wstr, -1, NULL, 0, NULL, NULL);
	char* str = new char[len + 1];
	memset(str, 0, len + 1);
	WideCharToMultiByte(CP_UTF8, 0, wstr, -1, str, len, NULL, NULL);
	if (wstr) delete[] wstr;
	return str;
}
char* U2G(const char* utf8)
{
	int len = MultiByteToWideChar(CP_UTF8, 0, utf8, -1, NULL, 0);
	wchar_t* wstr = new wchar_t[len + 1];
	memset(wstr, 0, len + 1);
	MultiByteToWideChar(CP_UTF8, 0, utf8, -1, wstr, len);
	len = WideCharToMultiByte(CP_ACP, 0, wstr, -1, NULL, 0, NULL, NULL);
	char* str = new char[len + 1];
	memset(str, 0, len + 1);
	WideCharToMultiByte(CP_ACP, 0, wstr, -1, str, len, NULL, NULL);
	if (wstr) delete[] wstr;
	return str;
}
string readXmlId(string xmlMsg) {
	printf("xmlMsg %s \n", xmlMsg.c_str());
	tinyxml2::XMLDocument doc;
	doc.Parse(U2G(xmlMsg.c_str()));
	tinyxml2::XMLElement* root = doc.RootElement();
	tinyxml2::XMLElement* typeEle = root->FirstChildElement("TYPE");
	tinyxml2::XMLElement* item = root->FirstChildElement("items");
	char * type = (char*)typeEle->GetText();
	if (strcmp(type, "S") == 0) {
		printf("1111");
		tinyxml2::XMLElement* itemsCs = item->FirstChildElement("EH_HR_UserItems_CS");
		tinyxml2::XMLElement* code = itemsCs->FirstChildElement("Code");
		return code->GetText();
	}
	return typeEle->GetText();
}
/*ȡûID
*/
string getUserIdOA(string email, string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, false);
		string temp; //Email=string&Name=string %E9%82%B5%E9%AA%8F%E9%BD%90
		temp.append("Email=&Name=%E9%82%B5%E4%BF%8A%E9%BD%90");// .append("Email=").append("&Name=ۿ"); //.append(email)
		printf("temp=%s\n", temp.c_str());
		const char* data = temp.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		//curl_easy_strerror
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
	return str_json;
}
//OAķϢ 
string readXmlMSG(string xmlMsg) {
	printf("xmlMsg %s \n", xmlMsg.c_str());
	tinyxml2::XMLDocument doc;
	doc.Parse(xmlMsg.c_str());
	tinyxml2::XMLElement* root = doc.RootElement();
	tinyxml2::XMLElement* succEle = root->FirstChildElement("Success");//״̬
	tinyxml2::XMLElement* messageEle = root->FirstChildElement("Message");//ԭ
	string msg = "";
	if (strcmp(succEle->GetText(), "false") == 0) {
		msg.append("֪ͨOAϵͳʧܣϵԱִ̼,ԭ: ");
		msg.append(U2G(messageEle->GetText()));
	}
	return msg;
}
/*֪ͨOA
*/
string ecnSendOA(string instanceId, string entityParamValues, string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, false);
		string temp;
		temp.append("workflowCode=EH_TE_ChangeNotice").append("&userCode=").
			append(instanceId).append("&finishStart=true").append("&entityParamValues=").
			append(G2U(entityParamValues.c_str()));
		printf("temp=%s\n", temp.c_str());
		const char* data = temp.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		//curl_easy_strerror
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
	string returnMsg = readXmlMSG(str_json);
	
	return returnMsg;
}
/*ɽӿڻȡĿָ
*/
string getAssignFromYP(string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		res = curl_easy_perform(curl);
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	return U2G(str_json.c_str());
}

void updatePiProject(string json,string url) {
	CURL *curl;
	CURLcode res;
	curl = curl_easy_init();
	std::stringstream out;
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		struct curl_slist *headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/json");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		const char *data = G2U(json.c_str());
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		res = curl_easy_perform(curl);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("str_json===>%s\n", str_json.c_str());
}